# programs.make -- used by Makefiles for executables only.
!IFDEF NODEBUG
ldebug = /RELEASE
!ELSE
!IFDEF PROFILE
ldebug = -debug:mapped,partial -debugtype:coff
!ELSE
ldebug = -debug:full -debugtype:cv
!ENDIF
!ENDIF
lflags =  /NODEFAULTLIB /INCREMENTAL:NO /PDB:NONE /NOLOGO \
	-align:0x1000 $(ldebug)
conlflags = $(lflags) -subsystem:console -entry:mainCRTStartup
dlllflags = $(lflags) -entry:_DllMainCRTStartup@12 -dll

!IFDEF PROFILE
optlibs =  cap.lib
!ELSE
optlibs =
!ENDIF
libc = libc.lib oldnames.lib kernel32.lib $(optlibs) advapi32.lib
libcmt = libcmt.lib oldnames.lib  kernel32.lib $(optlibs) advapi32.lib
libcdll = msvcrt.lib oldnames.lib  kernel32.lib $(optlibs) advapi32.lib user32.lib

# If linking against shared libraries, probably need special options.
shared_ldflags = 
library_ldflags = $(conlflags) $(lmap)

# Don't include $(CFLAGS), since ld -g under Linux forces
# static libraries, e.g., libc.a and libX*.a.
LDFLAGS = $(library_ldflags) $(XLDFLAGS)

# proglib is for web2c; 
# XLOADLIBES is for the installer.
LIBS =  $(libcdll)
LOADLIBES = $(proglib) $(kpathsea_srcdir)\kpathsea.lib $(LIBS) \
	$(top_srcdir)\win32dll\win32dll.lib

# May as well separate CCLD from CC.
CCLD = link
link_command = $(CCLD) /OUT:$@ $(LDFLAGS)
kpathsea_link = $(link_command)
dll_command = $(CCLD) /OUT:$@ $(dlllflags) $(ldebug)
# End of programs.make.

# Local Variables:
# mode: Makefile
# End: